<?php
include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if ($user_id == FALSE) {
    print "ログインが失効しています。\nこのアプリに再ログインしてください。";
    exit();
}

include "../modules/functions.php";
include "../modules/db_functions.php";

if (!isset($_POST["content"], $_POST["account_order_numbers"], $_POST["one_time_token"])) {
    print "データが正常に送信されませんでした";
    exit();
}

if (!$wakarana->check_one_time_token($user_id,$_POST["one_time_token"])) {
    print "ワンタイムトークンが無効です\nもう一度送信してください";
    exit();
}

if (!empty($_POST["image_transformation"])) {
    $image_transformation = json_decode($_POST["image_transformation"], TRUE);
    
    $tmp_file = array();
    $image_path_list = array();
    for ($img_kosu = 0; !empty($_FILES["image_".$img_kosu]["tmp_name"]) && $img_kosu < 4; $img_kosu++) {
        $tmp_file[$img_kosu] = tmpfile();
        $tmp_meta = stream_get_meta_data($tmp_file[$img_kosu]);
        $image_path_list[$img_kosu] = $tmp_meta["uri"];
        resize_image($_FILES["image_".$img_kosu]["tmp_name"], $image_path_list[$img_kosu], $image_transformation[$img_kosu]);
    }
} else {
    $img_kosu = 0;
}

$sa_config = parse_ini_file("../data/social_amniote.ini");

$sns_accounts = db_get_sns_accounts($user_id);
$content = urldecode($_POST["content"]);

if (!empty($_POST["question_id"])) {
    include "../modules/question.php";
    $q_data = get_question($_POST["question_id"]);
    
    answer_question($user_id, $_POST["question_id"], $content);
    
    $content .= "\n".get_application_url()."question/qa.php/".$q_data["question_id"];
    $content_m = "【質問】\n".$q_data["question"]."\n\n【回答】\n".$content;
} else {
    $content_m = $content;
}

$account_order_numbers = explode(",", $_POST["account_order_numbers"]);
for ($cnt = 0; !empty($sns_accounts[$cnt]); $cnt++) {
    if (array_search(strval($cnt + 1), $account_order_numbers) !== FALSE) {
        if ($sns_accounts[$cnt]["instance_url"] !== "twitter.com") {
            $img_id = array();
            for ($img_cnt = 0; $img_cnt < $img_kosu; $img_cnt++) {
                $img_id[$img_cnt] = upload_image_to_mastodon($sns_accounts[$cnt]["instance_url"], $sns_accounts[$cnt]["access_token"], $image_path_list[$img_cnt]);
            }
            
            $res = post_to_mastodon($sns_accounts[$cnt]["instance_url"], $sns_accounts[$cnt]["access_token"], $content_m, $img_id);
            
            if (!isset($res["id"])) {
                print "Mastodonへの投稿に失敗しました";
            }
        } else {
            $img_id = array();
            for ($img_cnt = 0; $img_cnt < $img_kosu; $img_cnt++) {
                $img_id[$img_cnt] = upload_image_to_twitter($sa_config["twitter_consumer_key"], $sa_config["twitter_consumer_secret"], $sns_accounts[$cnt]["access_token"], $sns_accounts[$cnt]["access_token_secret"], $image_path_list[$img_cnt]);
            }
            
            $res_data = post_to_twitter($sa_config["twitter_consumer_key"], $sa_config["twitter_consumer_secret"], $sns_accounts[$cnt]["access_token"], $sns_accounts[$cnt]["access_token_secret"], $content, $img_id);
            
            if (isset($res_data["errors"])) {
                print $res_data["errors"];
            }
        }
    }
}

print "[EOF]";
