<?php
include "./modules/info.php";

header("Cache-Control: public");

$sa_config = parse_ini_file("data/social_amniote.ini");
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title><?php print APPLICATION_NAME; ?></title>
    <meta property="og:title" content="<?php print APPLICATION_NAME; ?>">
    <meta property="og:description" content="SNSクライアント <?php print APPLICATION_NAME; ?>">
    <meta property="og:image" content="<?php print get_application_url(); ?>images/large_image.png">
    <meta property="twitter:card" content="summary_large_image">
    <link rel="stylesheet" href="main.css" type="text/css">
    <link rel="apple-touch-icon" href="apple-touch-icon.png">
    <link rel="shortcut icon" href="favicon.ico">
    <link rel="manifest" href="manifest.json">
</head>
<body>
    <header>
        <?php print APPLICATION_NAME; ?>
        <button id="menu_button"></button><div id="menu">
            <button onclick="location.href = 'setting/add_sns_account.php';">SNSアカウントの追加</button>
            <button onclick="location.href = 'setting/sns_accounts.php';">SNSアカウントの管理</button>
            <hr>
            <button onclick="location.href = 'question/answer.php';">あなた宛の匿名質問<span id="q_cnt"></span></button>
            <button onclick="request_question();">匿名質問を募集する</button>
            <hr>
            <button onclick="location.href = 'setting/config.php';">各種設定</button>
            <button onclick="logout_this_app();">ログアウト</button>
            <hr>
            <button onclick="open_square_popup('about_popup');">バージョン情報</button>
        </div>
    </header>
    <img src="" alt="" class="question_image"><button class="question_close_button" onclick="location.href = 'index.php';"></button>
    <div id="content_wrapper">
        <textarea id="content" placeholder="今なにしてる？"></textarea>
        <div id="image_box"></div>
    </div>
    <span id="char_cnt">0</span>/<span id="char_cnt_max">140</span>
    <div id="image_button">
        <input type="file" class="image_select">
        <input type="file" class="image_select">
        <input type="file" class="image_select">
        <input type="file" class="image_select">
    </div>
    <button id="post_button">投稿</button>
    <h3>投稿先SNSアカウント</h3>
    <div id="accounts">読み込み中...</div>
    <div id="please_wait">しばらくお待ちください...</div>
    <div id="image_edit" class="popup">
        <button class="popup_close_button" onclick="popup_close('image_edit');">×</button>
        <div id="image_edit_area">
            <img src="" alt="" id="image_preview">
            <div id="image_trimmed_top"></div><div id="image_trimmed_left"></div><div id="image_trimmed_right"></div><div id="image_trimmed_bottom"></div>
            <div id="image_trimmed_frame" class="trimming_frame"></div>
            <div id="image_over"></div>
        </div>
        <div id="image_edit_tab"><button onclick="image_dialog_active(0); set_image_edit_mode('rotate');">回転</button><button onclick="image_dialog_active(1); set_image_edit_mode('trimming');">トリミング</button></div>
        <div class="image_edit_dialog">
            画像をドラッグして回転できます<br>
            <br>
            <b>回転角度(時計回り) :</b> <input type="number" id="rotate_image_angle" min="-180" max="180">°<br>
            <br>
            <button onclick="set_rotate_angle(0)">0°</button> <button onclick="set_rotate_angle(90)">90°</button> <button onclick="set_rotate_angle(180)">180°</button> <button onclick="set_rotate_angle(-90)">-90°</button>
        </div>
        <div class="image_edit_dialog">
            画像をドラッグしてトリミングできます<br>
            <br>
            <b>始点 :</b> 左から<input type="number" id="trimming_x0" min="0" max="100">%　上から<input type="number" id="trimming_y0" min="0" max="100">%<br>
            <b>終点 :</b> 左から<input type="number" id="trimming_x1" min="0" max="100">%　上から<input type="number" id="trimming_y1" min="0" max="100">%<br>
            <br>
            <button onclick="trimming_reset();">リセット</button>
        </div>
    </div>
    <div id="popup_screen">
        <div class="square_popup" id="about_popup">
            <button class="popup_close_button" onclick="close_square_popup('about_popup');">×</button>
            <div style="text-align: center; margin-bottom: 15px;">
                <img src="apple-touch-icon.png" alt="<?php print APPLICATION_NAME; ?>" style="width: 96px; margin-top: 20px; margin-bottom: 10px;"><br>
                <b style="font-size: large;"><?php print APPLICATION_NAME; ?></b><br>
                バージョン : <?php print APPLICATION_VERSION; ?> 
            </div>
            <div style="padding: 10px 5px; color: #999999; font-size: small;">
                <?php print "<a href='".$sa_config["introduction_url"]."' target='_blank'>このアプリについて</a>"; ?> 
            </div>
        </div>
    </div>
    <script src="addition/main.js"></script>
</body>
</html>
