<?php
/*Wakarana-0.1 config.php*/

class wakarana_config{
    private $config = array();
    
    
    function __construct(){
        $this->config = parse_ini_file(dirname(__FILE__)."/config.ini");
    }
    
    
    function save($initialization = FALSE){
        if($initialization){
            $this->config["use_sqlite"] = TRUE;
            $this->config["sqlite_db_file"] = "wakarana.db";
            
            $this->config["mysql_server"] = "localhost";
            $this->config["mysql_user"] = "root";
            $this->config["mysql_pass"] = "";
            $this->config["mysql_db"] = "wakarana";
            
            $this->config["encryption_key"] = "PG6Dx0jK-SWTauSQfntLr0KzP0u3R6lHTmv4S9Y4hO8";
            
            $this->config["allow_mail_duplication"] = FALSE;
            $this->config["confirmation_mail_expire"] = 1800;
            
            $this->config["login_tokens_per_user"] = 4;
            $this->config["login_token_expire"] = 2592000;
            $this->config["one_time_tokens_per_user"] = 8;
            $this->config["one_time_token_expire"] = 43200;
            
            $this->config["attempt_logs_per_user"] = 20;
            $this->config["attempt_log_retention_time"] = 1209600;
        }
        
        $file_h = fopen(dirname(__FILE__)."/config.ini","w");
        
        if($this->config["use_sqlite"]){
            fwrite($file_h,"use_sqlite=true\n");
        }else{
            fwrite($file_h,"use_sqlite=false\n");
        }
        fwrite($file_h,"sqlite_db_file=\"".$this->config["sqlite_db_file"]."\"\n");
        fwrite($file_h,"\n");
        
        fwrite($file_h,"mysql_server=\"".$this->config["mysql_server"]."\"\n");
        fwrite($file_h,"mysql_user=\"".$this->config["mysql_user"]."\"\n");
        fwrite($file_h,"mysql_pass=\"".$this->config["mysql_pass"]."\"\n");
        fwrite($file_h,"mysql_db=\"".$this->config["mysql_db"]."\"\n");
        fwrite($file_h,"\n");
        
        fwrite($file_h,"encryption_key=\"".$this->config["encryption_key"]."\"\n");
        fwrite($file_h,"\n");
        
        if($this->config["allow_mail_duplication"]){
            fwrite($file_h,"allow_mail_duplication=true\n");
        }else{
            fwrite($file_h,"allow_mail_duplication=false\n");
        }
        fwrite($file_h,"confirmation_mail_expire=".$this->config["confirmation_mail_expire"]."\n");
        fwrite($file_h,"\n");
        
        fwrite($file_h,"login_tokens_per_user=".$this->config["login_tokens_per_user"]."\n");
        fwrite($file_h,"login_token_expire=".$this->config["login_token_expire"]."\n");
        fwrite($file_h,"one_time_tokens_per_user=".$this->config["one_time_tokens_per_user"]."\n");
        fwrite($file_h,"one_time_token_expire=".$this->config["one_time_token_expire"]."\n");
        fwrite($file_h,"\n");
        
        fwrite($file_h,"attempt_logs_per_user=".$this->config["attempt_logs_per_user"]."\n");
        fwrite($file_h,"attempt_log_retention_time=".$this->config["attempt_log_retention_time"]."\n");
        
        fclose($file_h);
    }
    
    
    function set_use_sqlite($use_sqlite){
        $this->config["use_sqlite"] = $use_sqlite;
        
        $this->save();
    }
    
    
    function set_sqlite_db_file($path){
        $this->config["sqlite_db_file"] = $path;
        
        $this->save();
    }
    
    
    function configure_mysql($mysql_server,$mysql_user,$mysql_pass,$mysql_db){
        $this->config["mysql_server"] = $mysql_server;
        $this->config["mysql_user"] = $mysql_user;
        $this->config["mysql_pass"] = $mysql_pass;
        $this->config["mysql_db"] = $mysql_db;
        
        $this->save();
    }
    
    
    function set_encryption_key($key = NULL){
        if(strlen($key) >= 1){
            $this->config["encryption_key"] = $key;
        }else{
            $this->config["encryption_key"] = rtrim(strtr(base64_encode(mcrypt_create_iv(32,MCRYPT_DEV_URANDOM)),"+/","-_"),"=");
        }
        
        $this->save();
    }
    
    
    function set_allow_mail_duplication($allow_mail_duplication){
        $this->config["allow_mail_duplication"] = $allow_mail_duplication;
        
        $this->save();
    }
    
    
    function set_confirmation_mail_expire($confirmation_mail_expire){
        $this->config["confirmation_mail_expire"] = $confirmation_mail_expire;
        
        $this->save();
    }
    
    
    function configure_login_token($login_tokens_per_user,$login_token_expire){
        $this->config["login_tokens_per_user"] = $login_tokens_per_user;
        $this->config["login_token_expire"] = $login_token_expire;
        
        $this->save();
    }
    
    
    function configure_one_time_token($one_time_tokens_per_user,$one_time_token_expire){
        $this->config["one_time_tokens_per_user"] = $one_time_tokens_per_user;
        $this->config["one_time_token_expire"] = $one_time_token_expire;
        
        $this->save();
    }
    
    
    function configure_attempt_log($attempt_logs_per_user,$attempt_log_retention_time){
        $this->config["attempt_logs_per_user"] = $attempt_logs_per_user;
        $this->config["attempt_log_retention_time"] = $attempt_log_retention_time;
        
        $this->save();
    }
    
    
    function setup_db(){
        if($this->config["use_sqlite"]){
            if(!extension_loaded("sqlite3")){
                print "エラー<br>ご利用のPHPにはSQLite3モジュールがインストールされていない、または、SQLite3モジュールが有効化されていません。";
                return FALSE;
            }
            
            $sqlite_obj = new SQLite3(dirname(__FILE__)."/".$this->config["sqlite_db_file"]);
            
            
            $sqlite_r1 = $sqlite_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'wakarana_users'");
            if($sqlite_r1 == FALSE){
                print "テーブルの確認に失敗しました。".$sqlite_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sqlite_r1->fetchArray(SQLITE3_ASSOC);
            if(!$q_kekka){
                $sqlite_r1_2 = $sqlite_obj->query("CREATE TABLE `wakarana_users`(`user_id` TEXT NOT NULL PRIMARY KEY, `password` TEXT NOT NULL, `user_name` TEXT, `mail_address` TEXT, `user_created` TEXT NOT NULL, `last_updated` TEXT NOT NULL, `last_access` TEXT NOT NULL, `status` INTEGER NOT NULL, `is_master` INTEGER NOT NULL)");
                if($sqlite_r1_2 == FALSE){
                    print "テーブル wakarana_users の作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r1_3 = $sqlite_obj->query("CREATE INDEX `idx_1` ON `wakarana_users`(`mail_address`)");
                if($sqlite_r1_3 == FALSE){
                    print "テーブル wakarana_users のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r1_4 = $sqlite_obj->query("CREATE INDEX `idx_2` ON `wakarana_users`(`user_name`)");
                if($sqlite_r1_4 == FALSE){
                    print "テーブル wakarana_users のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r1_5 = $sqlite_obj->query("CREATE INDEX `idx_3` ON `wakarana_users`(`user_created`)");
                if($sqlite_r1_5 == FALSE){
                    print "テーブル wakarana_users のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r1_6 = $sqlite_obj->query("CREATE INDEX `idx_4` ON `wakarana_users`(`last_updated`)");
                if($sqlite_r1_6 == FALSE){
                    print "テーブル wakarana_users のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            
            $sqlite_r2 = $sqlite_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'wakarana_login_tokens'");
            if($sqlite_r2 == FALSE){
                print "テーブルの確認に失敗しました。".$sqlite_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
            if(!$q_kekka){
                $sqlite_r2_2 = $sqlite_obj->query("CREATE TABLE `wakarana_login_tokens`(`token` TEXT NOT NULL PRIMARY KEY, `user_id` TEXT NOT NULL, `token_created` TEXT NOT NULL, `expire` TEXT NOT NULL)");
                if($sqlite_r2_2 == FALSE){
                    print "テーブル wakarana_login_tokens の作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r2_3 = $sqlite_obj->query("CREATE INDEX `idx_5` ON `wakarana_login_tokens`(`user_id`,`token_created`)");
                if($sqlite_r2_3 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r2_4 = $sqlite_obj->query("CREATE INDEX `idx_6` ON `wakarana_login_tokens`(`token_created`)");
                if($sqlite_r2_4 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r2_5 = $sqlite_obj->query("CREATE INDEX `idx_7` ON `wakarana_login_tokens`(`expire`)");
                if($sqlite_r2_5 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            
            $sqlite_r3 = $sqlite_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'wakarana_privileges'");
            if($sqlite_r3 == FALSE){
                print "テーブルの確認に失敗しました。".$sqlite_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sqlite_r3->fetchArray(SQLITE3_ASSOC);
            if(!$q_kekka){
                $sqlite_r3_2 = $sqlite_obj->query("CREATE TABLE `wakarana_privileges`(`user_id` char(63) NOT NULL, `permission_id` char(127) NOT NULL, PRIMARY KEY(`user_id`,`permission_id`))");
                if($sqlite_r3_2 == FALSE){
                    print "テーブル wakarana_privileges の作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r3_3 = $sqlite_obj->query("CREATE INDEX `idx_8` ON `wakarana_privileges`(`permission_id`,`user_id`)");
                if($sqlite_r3_3 == FALSE){
                    print "テーブル wakarana_privileges のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            
            $sqlite_r4 = $sqlite_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'wakarana_one_time_tokens'");
            if($sqlite_r4 == FALSE){
                print "テーブルの確認に失敗しました。".$sqlite_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sqlite_r4->fetchArray(SQLITE3_ASSOC);
            if(!$q_kekka){
                $sqlite_r4_2 = $sqlite_obj->query("CREATE TABLE `wakarana_one_time_tokens`(`token` TEXT NOT NULL PRIMARY KEY, `user_id` TEXT NOT NULL, `token_created` TEXT NOT NULL)");
                if($sqlite_r4_2 == FALSE){
                    print "テーブル wakarana_login_tokens の作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r4_3 = $sqlite_obj->query("CREATE INDEX `idx_9` ON `wakarana_one_time_tokens`(`user_id`,`token_created`)");
                if($sqlite_r4_3 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r4_4 = $sqlite_obj->query("CREATE INDEX `idx_10` ON `wakarana_one_time_tokens`(`token_created`)");
                if($sqlite_r4_4 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            
            $sqlite_r5 = $sqlite_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'wakarana_attempt_logs'");
            if($sqlite_r5 == FALSE){
                print "テーブルの確認に失敗しました。".$sqlite_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sqlite_r5->fetchArray(SQLITE3_ASSOC);
            if(!$q_kekka){
                $sqlite_r5_2 = $sqlite_obj->query("CREATE TABLE `wakarana_attempt_logs`(`user_id` TEXT NOT NULL, `succeeded` INTEGER NOT NULL, `attempt_datetime` TEXT NOT NULL)");
                if($sqlite_r5_2 == FALSE){
                    print "テーブル wakarana_login_tokens の作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r5_3 = $sqlite_obj->query("CREATE INDEX `idx_11` ON `wakarana_attempt_logs`(`user_id`,`attempt_datetime`)");
                if($sqlite_r5_3 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            
            $sqlite_r6 = $sqlite_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'wakarana_mail_confirmation'");
            if($sqlite_r6 == FALSE){
                print "テーブルの確認に失敗しました。".$sqlite_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sqlite_r6->fetchArray(SQLITE3_ASSOC);
            if(!$q_kekka){
                $sqlite_r6_2 = $sqlite_obj->query("CREATE TABLE `wakarana_mail_confirmation`(`token` TEXT NOT NULL PRIMARY KEY, `user_id` TEXT UNIQUE, `mail_address` TEXT NOT NULL, `purpose` INTEGER NOT NULL, `token_created` TEXT NOT NULL)");
                if($sqlite_r6_2 == FALSE){
                    print "テーブル wakarana_login_tokens の作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r6_3 = $sqlite_obj->query("CREATE INDEX `idx_12` ON `wakarana_mail_confirmation`(`mail_address`,`user_id`)");
                if($sqlite_r6_3 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $sqlite_r6_4 = $sqlite_obj->query("CREATE INDEX `idx_13` ON `wakarana_mail_confirmation`(`token_created`)");
                if($sqlite_r6_4 == FALSE){
                    print "テーブル wakarana_login_tokens のインデックスの作成に失敗しました。".$sqlite_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            
            $sqlite_obj->close();
            
        }else{
            $mysql_obj = new mysqli($this->config["mysql_server"],$this->config["mysql_user"],$this->config["mysql_pass"]);
            if ($mysql_obj->connect_errno){
                print "データベース接続に失敗しました。".$mysql_obj->connect_error;
                return FALSE;
            }
            
            $mysql_obj->set_charset("utf8");
            
            $mysql_r1 = $mysql_obj->query("SHOW DATABASES LIKE '".$this->config["mysql_db"]."'");
            if ($mysql_r1 == FALSE){
                print "データベースの確認に失敗しました。".$mysql_obj->error;
                return FALSE;
            }
            
            $q_kekka = $mysql_r1->fetch_assoc();
            if(!$q_kekka){
                $mysql_r1_2 = $mysql_obj->query("CREATE DATABASE `".$this->config["mysql_db"]."` default character set utf8");
                if ($mysql_r1_2 == FALSE){
                    print "データベースの作成に失敗しました。".$mysql_obj->error."<br>データベース作成権限をご確認ください。";
                    return FALSE;
                }
            }
            
            $mysql_obj->select_db($this->config["mysql_db"]);
            
            $mysql_r2 = $mysql_obj->query("SHOW TABLES FROM `".$this->config["mysql_db"]."` LIKE 'wakarana_users'");
            if ($mysql_r2 == FALSE){
                print "テーブルの確認に失敗しました。".$mysql_obj->error;
                return FALSE;
            }
        
            if($mysql_r2->fetch_assoc() == NULL){
                $mysql_r2_2 = $mysql_obj->query("CREATE TABLE `wakarana_users`(`user_id` char(63) NOT NULL PRIMARY KEY, `password` varchar(128) NOT NULL, `user_name` char(63), `mail_address` varchar(255), `user_created` datetime NOT NULL, `last_updated` datetime NOT NULL, `last_access` datetime NOT NULL, `status` tinyint NOT NULL, `is_master` tinyint NOT NULL, INDEX idx_1(`mail_address`), INDEX idx_2(`user_name`), INDEX idx_3(`user_created`), INDEX idx_4(`last_updated`))");
                if ($mysql_r2_2 == FALSE){
                    print "テーブル wakarana_users の作成に失敗しました。".$mysql_obj->error;
                    return FALSE;
                }
            }
            
            $mysql_r3 = $mysql_obj->query("SHOW TABLES FROM `".$this->config["mysql_db"]."` LIKE 'wakarana_login_tokens'");
            if ($mysql_r3 == FALSE){
                print "テーブルの確認に失敗しました。".$mysql_obj->error;
                return FALSE;
            }
            
            if($mysql_r3->fetch_assoc() == NULL){
                $mysql_r3_2 = $mysql_obj->query("CREATE TABLE `wakarana_login_tokens`(`token` char(43) NOT NULL PRIMARY KEY, `user_id` char(63) NOT NULL, `token_created` datetime NOT NULL, `expire` datetime NOT NULL, INDEX idx_5(`user_id`,`token_created`), INDEX idx_6(`token_created`), INDEX idx_7(`expire`))");
                if ($mysql_r3_2 == FALSE){
                    print "テーブル wakarana_login_tokens の作成に失敗しました。".$mysql_obj->error;
                    return FALSE;
                }
            }
            
            $mysql_r4 = $mysql_obj->query("SHOW TABLES FROM `".$this->config["mysql_db"]."` LIKE 'wakarana_privileges'");
            if ($mysql_r4 == FALSE){
                print "テーブルの確認に失敗しました。".$mysql_obj->error;
            }
            
            if($mysql_r4->fetch_assoc() == NULL){
                $mysql_r4_2 = $mysql_obj->query("CREATE TABLE `wakarana_privileges`(`user_id` char(63) NOT NULL, `permission_id` char(127) NOT NULL, PRIMARY KEY(`user_id`,`permission_id`), INDEX idx_8(`permission_id`,`user_id`))");
                if ($mysql_r4_2 == FALSE){
                    print "テーブル wakarana_privileges の作成に失敗しました。".$mysql_obj->error;
                    return FALSE;
                }
            }
            
            $mysql_r5 = $mysql_obj->query("SHOW TABLES FROM `".$this->config["mysql_db"]."` LIKE 'wakarana_one_time_tokens'");
            if ($mysql_r5 == FALSE){
                print "テーブルの確認に失敗しました。".$mysql_obj->error;
            }
            
            if($mysql_r5->fetch_assoc() == NULL){
                $mysql_r5_2 = $mysql_obj->query("CREATE TABLE `wakarana_one_time_tokens`(`token` char(43) NOT NULL PRIMARY KEY, `user_id` char(63) NOT NULL, `token_created` datetime NOT NULL, INDEX idx_9(`user_id`,`token_created`), INDEX idx_10(`token_created`))");
                if ($mysql_r5_2 == FALSE){
                    print "テーブル wakarana_privileges の作成に失敗しました。".$mysql_obj->error;
                    return FALSE;
                }
            }
            
            $mysql_r6 = $mysql_obj->query("SHOW TABLES FROM `".$this->config["mysql_db"]."` LIKE 'wakarana_attempt_logs'");
            if ($mysql_r6 == FALSE){
                print "テーブルの確認に失敗しました。".$mysql_obj->error;
            }
            
            if($mysql_r6->fetch_assoc() == NULL){
                $mysql_r6_2 = $mysql_obj->query("CREATE TABLE `wakarana_attempt_logs`(`user_id` char(63) NOT NULL, `succeeded` tinyint NOT NULL, `attempt_datetime` datetime NOT NULL, INDEX idx_11(`user_id`,`attempt_datetime`))");
                if ($mysql_r6_2 == FALSE){
                    print "テーブル wakarana_privileges の作成に失敗しました。".$mysql_obj->error;
                    return FALSE;
                }
            }
            
            $mysql_r7 = $mysql_obj->query("SHOW TABLES FROM `".$this->config["mysql_db"]."` LIKE 'wakarana_mail_confirmation'");
            if ($mysql_r7 == FALSE){
                print "テーブルの確認に失敗しました。".$mysql_obj->error;
            }
            
            if($mysql_r7->fetch_assoc() == NULL){
                $mysql_r7_2 = $mysql_obj->query("CREATE TABLE `wakarana_mail_confirmation`(`token` char(43) NOT NULL PRIMARY KEY, `user_id` char(63) UNIQUE, `mail_address` varchar(255) NOT NULL, `purpose` tinyint NOT NULL, `token_created` datetime NOT NULL, INDEX idx_12(`mail_address`,`user_id`), INDEX idx_13(`token_created`))");
                if ($mysql_r7_2 == FALSE){
                    print "テーブル wakarana_privileges の作成に失敗しました。".$mysql_obj->error;
                    return FALSE;
                }
            }
            
            $mysql_obj->close();
            return TRUE;
        }
    }
}
?>