<?php
/*Wakarana-0.1 main.php*/
define("WAKARANA_STATUS_DISABLE",0);
define("WAKARANA_STATUS_NORMAL",1);
define("WAKARANA_STATUS_MAIL_UNCONFIRMED",3);


class wakarana{
    private $config = array();
    private $db_obj = array();
    
    function __construct(){
        $this->config = parse_ini_file(dirname(__FILE__)."/config.ini");
        
        if($this->config["use_sqlite"]){
            $this->db_obj = new SQLite3(dirname(__FILE__)."/".$this->config["sqlite_db_file"]);
            
        }else{
            $this->db_obj = new mysqli($this->config["mysql_server"],$this->config["mysql_user"],$this->config["mysql_pass"]);
            if ($this->db_obj->connect_errno){
                print "データベース接続に失敗しました。".$this->db_obj->connect_error;
                return FALSE;
            }
            
            $this->db_obj->set_charset("utf8");
            
            $this->db_obj->select_db($this->config["mysql_db"]);
        }
    }
    
    
    private function encrypt($str){
        if(empty($str)){
            return "";
        }
        
        $td = mcrypt_module_open(MCRYPT_RIJNDAEL_256,"",MCRYPT_MODE_ECB,"");
        $key = substr($this->config["encryption_key"],0,mcrypt_enc_get_key_size($td));
        $iv = str_pad("",mcrypt_enc_get_key_size($td));
        
        mcrypt_generic_init($td,$key,$iv);
        
        $kekka = base64_encode(mcrypt_generic($td,$str));
        
        mcrypt_generic_deinit($td);
        mcrypt_module_close($td);
        
        return $kekka;
    }
    
    
    private function decrypt($str){
        if(empty($str)){
            return "";
        }
        
        $td = mcrypt_module_open(MCRYPT_RIJNDAEL_256,"",MCRYPT_MODE_ECB,"");
        $key = substr($this->config["encryption_key"],0,mcrypt_enc_get_key_size($td));
        $iv = str_pad("",mcrypt_enc_get_key_size($td));
        
        mcrypt_generic_init($td,$key,$iv);
        
        $kekka = mdecrypt_generic($td,base64_decode($str));
        
        mcrypt_generic_deinit($td);
        mcrypt_module_close($td);
        
        return $kekka;
    }
    
    
    function escape_id($id,$len = 60){
        return substr(preg_replace("/[^0-9a-z_]/","",strtolower($id)),0,$len);
    }
    
    
    function get_user_info($user_id,$decrypt = TRUE){
        $user_id = $this->escape_id($user_id);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT * FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC);
        }else{
            $sql_r1 = $this->db_obj->query("SELECT * FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetch_assoc();
        }
        
        if($q_kekka){
            if($decrypt){
                $q_kekka["mail_address"] = $this->decrypt($q_kekka["mail_address"]);
            }
            
            return $q_kekka;
        }else{
            return NULL;
        }
    }
    
    
    function mail_exists($mail_address){
        if(strlen($mail_address) == 0){
            return NULL;
        }
        
        $mail_address_q = $this->encrypt($mail_address);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT `user_id` FROM `wakarana_users` WHERE `mail_address`='".$mail_address_q."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC);
        }else{
            $sql_r1 = $this->db_obj->query("SELECT `user_id` FROM `wakarana_users` WHERE `mail_address`='".$mail_address_q."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetch_assoc();
        }
        
        if($q_kekka){
            return TRUE;
        }else{
            return FALSE;
        }
    }
    
    
    function add_user($user_id,$password,$user_name = "匿名",$mail_address = NULL,$is_master = FALSE,$status = WAKARANA_STATUS_NORMAL){
        if(!$this->config["allow_mail_duplication"]){
            if($this->mail_exists($mail_address)){
                return FALSE;
            }
        }
        
        $user_id = $this->escape_id($user_id);
        $password_hash = hash("sha512",$password.hash("sha512",$user_id));
        if($mail_address !== NULL && $mail_address !== ""){
            $mail_address_q = "'".$this->encrypt($mail_address)."'";
        }else{
            $mail_address_q = "NULL";
        }
        if($is_master){
            $is_master_num = 1;
        }else{
            $is_master_num = 0;
        }
        $status = intval($status);
        
        $ima = date("Y-m-d H:i:s");
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("INSERT INTO `wakarana_users`(`user_id`,`password`,`user_name`,`mail_address`,`user_created`,`last_updated`,`last_access`,`status`,`is_master`) VALUES ('".$user_id."','".$password_hash."','".$this->db_obj->escapeString($user_name)."',".$mail_address_q.",'".$ima."','".$ima."','".$ima."',".$status.",".$is_master_num.")");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("INSERT INTO `wakarana_users`(`user_id`,`password`,`user_name`,`mail_address`,`user_created`,`last_updated`,`last_access`,`status`,`is_master`) VALUES ('".$user_id."','".$password_hash."','".$this->db_obj->real_escape_string($user_name)."',".$mail_address_q.",'".$ima."','".$ima."','".$ima."',".$status.",".$is_master_num.")");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
        
        return $user_id;
    }
    
    
    function change_user_data($user_id,$password = NULL,$user_name = NULL,$mail_address = NULL,$is_master = NULL,$status = NULL){
        $user_id = $this->escape_id($user_id);
        
        $data = $this->get_user_info($user_id,FALSE);
        
        if($password === NULL){
            $password_hash = $data["password"];
        }else{
            $password_hash = hash("sha512",$password.hash("sha512",$user_id));
        }
        
        if($user_name === NULL){
            $user_name = $data["user_name"];
        }
        
        if($mail_address === ""){
            $mail_address_q = $data["mail_address"];
        }else{
            $mail_address_q = $this->encrypt($mail_address);
            
            if($mail_address_q !== $data["mail_address"]){
                if($this->mail_exists($mail_address)){
                    return FALSE;
                }
            }
        }
        
        if($is_master === NULL){
            $is_master_num = $data["is_master"];
        }else{
            if($is_master){
                $is_master_num = 1;
            }else{
                $is_master_num = 0;
            }
        }
        
        if($status === NULL){
            $status = $data["status"];
        }else{
            $status = intval($status);
        }
        
        $ima = date("Y-m-d H:i:s");
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("UPDATE `wakarana_users` SET `password`='".$password_hash."',`user_name` = '".$this->db_obj->escapeString($user_name)."', `mail_address` = '".$mail_address_q."', `last_updated` = '".$ima."', `status` = ".$status.", `is_master` = ".$is_master_num." WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("UPDATE `wakarana_users` SET `password`='".$password_hash."',`user_name` = '".$this->db_obj->real_escape_string($user_name)."', `mail_address` = '".$mail_address_q."', `last_updated` = '".$ima."', `status` = ".$status.", `is_master` = ".$is_master_num." WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
        
        if($status == WAKARANA_STATUS_DISABLE){
            $this->delete_all_tokens($user_id);
        }
        
        return TRUE;
    }
    
    
    function delete_user($user_id){
        $user_id = $this->escape_id($user_id);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return NULL;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return NULL;
            }
        }
        
        $this->delete_all_tokens($user_id);
        $this->delete_attempt_logs($user_id);
        $this->delete_privilege($user_id);
        
        return TRUE;
    }
    
    
    function get_all_users($start = 0,$limit = 100){
        $start = intval($start);
        $limit = intval($limit);
        
        $kekka_list = array();
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT * FROM `wakarana_users` order by `user_created` limit ".$start.",".$limit);
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            for($cnt = 0; $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
                $kekka_list[$cnt] = $q_kekka;
            }
        }else{
            $sql_r1 = $this->db_obj->query("SELECT * FROM `wakarana_users` order by `user_created` limit ".$start.",".$limit);
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            for($cnt = 0; $q_kekka = $sql_r1->fetch_assoc(); $cnt++){
                $kekka_list[$cnt] = $q_kekka;
            }
        }
        
        return $kekka_list;
    }
            
    
    function add_privilege($user_id,$permission_id){
        $user_id = $this->escape_id($user_id);
        $permission_id = $this->escape_id($permission_id,120);
        
        if($permission_id === "master"){
            print "「master」は利用できません。";
            return FALSE;
        }
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("INSERT INTO `wakarana_privileges`(`user_id`,`permission_id`) VALUES ('".$user_id."','".$permission_id."')");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("INSERT INTO `wakarana_privileges`(`user_id`,`permission_id`) VALUES ('".$user_id."','".$permission_id."')");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
        
        return TRUE;
    }
    
    
    function check_privilege($user_id,$permission_id,$always_allow_master = TRUE){
        $user_id = $this->escape_id($user_id);
        $permission_id = $this->escape_id($permission_id,120);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT `user_id` FROM `wakarana_privileges` WHERE `user_id`='".$user_id."' AND `permission_id`='".$permission_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return NULL;
            }
            
            $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC);
        }else{
            $sql_r1 = $this->db_obj->query("SELECT `user_id` FROM `wakarana_privileges` WHERE `user_id`='".$user_id."' AND `permission_id`='".$permission_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return NULL;
            }
            
            $q_kekka = $sql_r1->fetch_assoc();
        }
        
        if($q_kekka){
            return TRUE;
        }elseif($always_allow_master){
            if($this->config["use_sqlite"]){
                $sql_r1 = $this->db_obj->query("SELECT `is_master` FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $q_kekka_2 = $sql_r1->fetchArray(SQLITE3_ASSOC);
            }else{
                $sql_r1 = $this->db_obj->query("SELECT `is_master` FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->error;
                    return FALSE;
                }
            
                $q_kekka_2 = $sql_r1->fetch_assoc();
            }
            
            if($q_kekka_2["is_master"] == 1){//MySQLは文字列型で出力される仕様のため型比較なし
                return TRUE;
            }else{
                return FALSE;
            }
        }else{
            return FALSE;
        }
    }
    
    
    function delete_privilege($user_id = NULL,$permission_id = NULL){
        if($user_id != NULL){
            $user_id = $this->escape_id($user_id);
                        
            if($permission_id == NULL){
                if($this->config["use_sqlite"]){
                    $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_privileges` WHERE `user_id`='".$user_id."'");
                    if($sql_r1 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                        return FALSE;
                    }
                }else{
                    $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_privileges` WHERE `user_id`='".$user_id."'");
                    if($sql_r1 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->error;
                        return FALSE;
                    }
                }
            }else{
                $permission_id = $this->escape_id($permission_id,120);
                
                if($this->config["use_sqlite"]){
                    $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_privileges` WHERE `user_id`='".$user_id."' AND `permission_id`='".$permission_id."'");
                    if($sql_r1 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                        return FALSE;
                    }
                }else{
                    $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_privileges` WHERE `user_id`='".$user_id."' AND `permission_id`='".$permission_id."'");
                    if($sql_r1 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->error;
                        return FALSE;
                    }
                }
            }
        }else{
            if($permission_id == NULL){
                return FALSE;
            }
            
            $permission_id = $this->escape_id($permission_id,120);
            
            if($this->config["use_sqlite"]){
                $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_privileges` WHERE `permission_id`='".$permission_id."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
            }else{
                $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_privileges` WHERE `permission_id`='".$permission_id."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->error;
                    return FALSE;
                }
            }
        }
        
        return TRUE;
    }
    
    
    function create_token(){
        return rtrim(strtr(base64_encode(mcrypt_create_iv(32,MCRYPT_DEV_URANDOM)),"+/","-_"),"=");
    }
    
    
    function delete_old_login_tokens(){
        $ima = date("Y-m-d H:i:s");
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `expire` < '".$ima."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `expire` < '".$ima."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
        
        return TRUE;
    }
    
    
    function delete_all_tokens($user_id){
        $user_id = $this->escape_id($user_id);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sql_r2 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `user_id` = '".$user_id."'");
            if($sql_r2 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $sql_r2 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `user_id` = '".$user_id."'");
            if($sql_r2 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
    }
    
    
    function add_attempt_logs($user_id,$succeeded){
        $user_id = $this->escape_id($user_id);
        if($succeeded){
            $succeeded_num = 1;
        }else{
            $succeeded_num = 0;
        }
        
        $ima = time();
        $kako = date("Y-m-d H:i:s",$ima - $this->config["attempt_log_retention_time"]);
        
        if($this->config["use_sqlite"]){//SQLiteとMySQLで最古ログを削除するSQLは異なる
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_attempt_logs` WHERE `attempt_datetime` < '".$kako."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sql_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `wakarana_attempt_logs` WHERE `user_id`='".$user_id."'");
            if($sql_r2 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka_2 = $sql_r2->fetchArray(SQLITE3_ASSOC);
            if($q_kekka_2["cnt"] >= $this->config["attempt_logs_per_user"]){
                $sql_r3 = $this->db_obj->query("DELETE FROM `wakarana_attempt_logs` WHERE `user_id`='".$user_id."' AND not exists(SELECT * FROM `wakarana_attempt_logs` AS `tbl` WHERE `tbl`.`user_id`='".$user_id."' AND `wakarana_attempt_logs`.`attempt_datetime` > `tbl`.`attempt_datetime`)");
                if($sql_r3 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            $sql_r4 = $this->db_obj->query("INSERT INTO `wakarana_attempt_logs`(`user_id`,`succeeded`,`attempt_datetime`) VALUES ('".$user_id."',".$succeeded_num.",'".date("Y-m-d H:i:s",$ima)."')");
            if($sql_r4 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_attempt_logs` WHERE `attempt_datetime` < '".$kako."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $sql_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `wakarana_attempt_logs` WHERE `user_id`='".$user_id."'");
            if($sql_r2 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $q_kekka_2 = $sql_r2->fetch_assoc();
            if($q_kekka_2["cnt"] >= $this->config["attempt_logs_per_user"]){
                $sql_r3 = $this->db_obj->query("DELETE FROM `wakarana_attempt_logs` WHERE `user_id`='".$user_id."' order by `attempt_datetime` limit 1");
                if($sql_r3 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->error;
                    return FALSE;
                }
            }
            
            $sql_r4 = $this->db_obj->query("INSERT INTO `wakarana_attempt_logs`(`user_id`,`succeeded`,`attempt_datetime`) VALUES ('".$user_id."',".$succeeded_num.",'".date("Y-m-d H:i:s",$ima)."')");
            if($sql_r4 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
        
        return TRUE;
    }
    
    
    function get_attempt_logs($user_id){
        $user_id = $this->escape_id($user_id);
        
        $kekka_list = array();
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT * FROM `wakarana_attempt_logs` WHERE `user_id`='".$user_id."' order by `attempt_datetime` DESC");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            for($cnt = 0; $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
                $kekka_list[$cnt] = $q_kekka;
            }
        }else{
            $sql_r1 = $this->db_obj->query("SELECT * FROM `wakarana_attempt_logs` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            for($cnt = 0; $q_kekka = $sql_r1->fetch_assoc(); $cnt++){
                $kekka_list[$cnt] = $q_kekka;
            }
        }
        
        return $kekka_list;
    }
    
    
    function delete_attempt_logs($user_id){
        $user_id = $this->escape_id($user_id);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_attempt_logs` WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_attempt_logs` WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
    }
    
    
    function update_last_access($user_id){
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("UPDATE `wakarana_users` SET `last_access` = '".date("Y-m-d H:i:s")."' WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("UPDATE `wakarana_users` SET `last_access` = '".date("Y-m-d H:i:s")."' WHERE `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
    }
    
    
    function check_password($user_id,$password){
        $user_id = $this->escape_id($user_id);
        $password_hash = hash("sha512",$password.hash("sha512",$user_id));
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT `password` FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC);
        }else{
            $sql_r1 = $this->db_obj->query("SELECT `password` FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetch_assoc();
        }
        
        if($q_kekka){
            if($q_kekka["password"] === $password_hash){
                return TRUE;
            }
        }
        
        return FALSE;
    }
    
    
    function login($user_id,$password){
        $user_id = $this->escape_id($user_id);
        $password_hash = hash("sha512",$password.hash("sha512",$user_id));
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("SELECT `password`,`status` FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC);
        }else{
            $sql_r1 = $this->db_obj->query("SELECT `password`,`status` FROM `wakarana_users` WHERE `user_id`='".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $q_kekka = $sql_r1->fetch_assoc();
        }
        
        if($q_kekka){
            if($q_kekka["password"] === $password_hash && $q_kekka["status"] == WAKARANA_STATUS_NORMAL){//MySQLは文字列型で出力される仕様のためstatusの型比較なし
                $token = $this->create_token();
                
                $ima = time();
                $expire = $ima + $this->config["login_token_expire"];
                
                $this->delete_old_login_tokens();
                
                if($this->config["use_sqlite"]){//SQLiteとMySQLで最古トークンを削除するSQLは異なる
                    $sql_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `wakarana_login_tokens` WHERE `user_id`='".$user_id."'");
                    if($sql_r2 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                        return FALSE;
                    }
                    
                    $q_kekka_2 = $sql_r2->fetchArray(SQLITE3_ASSOC);
                    if($q_kekka_2["cnt"] >= $this->config["login_tokens_per_user"]){
                        $sql_r3 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `user_id`='".$user_id."' AND not exists(SELECT * FROM `wakarana_login_tokens` AS `tbl` WHERE `tbl`.`user_id`='".$user_id."' AND `wakarana_login_tokens`.`token_created` > `tbl`.`token_created`)");
                        if($sql_r3 === FALSE){
                            print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                            return FALSE;
                        }
                    }
                    
                    $sql_r4 = $this->db_obj->query("INSERT INTO `wakarana_login_tokens`(`token`,`user_id`,`token_created`,`expire`) VALUES ('".$token."','".$user_id."','".date("Y-m-d H:i:s",$ima)."','".date("Y-m-d H:i:s",$expire)."')");
                    if($sql_r4 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                        return FALSE;
                    }
                }else{
                    $sql_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `wakarana_login_tokens` WHERE `user_id`='".$user_id."'");
                    if($sql_r2 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->error;
                        return FALSE;
                    }
                    
                    $q_kekka_2 = $sql_r2->fetch_assoc();
                    if($q_kekka_2["cnt"] >= $this->config["login_tokens_per_user"]){
                        $sql_r3 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `user_id`='".$user_id."' order by `token_created` limit 1");
                        if($sql_r3 === FALSE){
                            print "SQL文の実行に失敗しました。".$this->db_obj->error;
                            return FALSE;
                        }
                    }
                    
                    $sql_r4 = $this->db_obj->query("INSERT INTO `wakarana_login_tokens`(`token`,`user_id`,`token_created`,`expire`) VALUES ('".$token."','".$user_id."','".date("Y-m-d H:i:s",$ima)."','".date("Y-m-d H:i:s",$expire)."')");
                    if($sql_r4 === FALSE){
                        print "SQL文の実行に失敗しました。".$this->db_obj->error;
                        return FALSE;
                    }
                }
                
                $kekka = setcookie("wakarana",$token,$expire,"/","",FALSE,TRUE);
                
                if($kekka){
                    $this->add_attempt_logs($user_id,TRUE);
                    $this->update_last_access($user_id);
                    
                    return TRUE;
                }
            }else{
                $this->add_attempt_logs($user_id,FALSE);
            }
        }
        
        return FALSE;
    }
    
    
    function check($permission_id = NULL){
        if(isset($_COOKIE["wakarana"])){
            if($this->config["use_sqlite"]){
                $sql_r1 = $this->db_obj->query("SELECT `user_id`,strftime('%s',`expire`) AS `expire` FROM `wakarana_login_tokens` WHERE `token`='".$this->db_obj->escapeString($_COOKIE["wakarana"])."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
                
                $q_kekka = $sql_r1->fetchArray(SQLITE3_ASSOC);
            }else{
                $sql_r1 = $this->db_obj->query("SELECT `user_id`,unix_timestamp(`expire`) AS `expire` FROM `wakarana_login_tokens` WHERE `token`='".$this->db_obj->real_escape_string($_COOKIE["wakarana"])."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->error;
                    return FALSE;
                }
                
                $q_kekka = $sql_r1->fetch_assoc();
            }
            
            if($q_kekka){
                if($q_kekka["expire"] > time()){
                    if($permission_id === NULL){
                        return $q_kekka["user_id"];
                    }else{
                        if($this->check_privilege($q_kekka["user_id"],$permission_id)){
                            return $q_kekka["user_id"];
                        }
                    }
                }
            }
        }
        
        return FALSE;
    }
    
    
    function logout(){
        $user_id = $this->check();
        
        if($user_id !== FALSE){
            if($this->config["use_sqlite"]){
                $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `token`='".$this->db_obj->escapeString($_COOKIE["wakarana"])."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
            }else{
                $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_login_tokens` WHERE `token`='".$this->db_obj->real_escape_string($_COOKIE["wakarana"])."'");
                if($sql_r1 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->error;
                    return FALSE;
                }
            }
            
            $kako = time() - 3600;
            setcookie("wakarana","",$kako,"/");
            
            $this->update_last_access($user_id);
            
            return TRUE;
        }else{
            return FALSE;
        }
    }
    
    
    function create_one_time_token($user_id){
        $user_id = $this->escape_id($user_id);
        
        $token = $this->create_token();
        
        $ima = time();
        $kako = date("Y-m-d H:i:s",$ima - $this->config["one_time_token_expire"]);
        
        if($this->config["use_sqlite"]){//SQLiteとMySQLで最古トークンを削除するSQLは異なる
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `token_created` < '".$kako."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sql_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `wakarana_one_time_tokens` WHERE `user_id`='".$user_id."'");
            if($sql_r2 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $q_kekka_2 = $sql_r2->fetchArray(SQLITE3_ASSOC);
            if($q_kekka_2["cnt"] >= $this->config["one_time_tokens_per_user"]){
                $sql_r3 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `user_id`='".$user_id."' AND not exists(SELECT * FROM `wakarana_one_time_tokens` AS `tbl` WHERE `tbl`.`user_id`='".$user_id."' AND `wakarana_one_time_tokens`.`token_created` > `tbl`.`token_created`)");
                if($sql_r3 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            $sql_r4 = $this->db_obj->query("INSERT INTO `wakarana_one_time_tokens`(`token`,`user_id`,`token_created`) VALUES ('".$token."','".$user_id."','".date("Y-m-d H:i:s",$ima)."')");
            if($sql_r4 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `token_created` < '".$kako."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $sql_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `wakarana_one_time_tokens` WHERE `user_id`='".$user_id."'");
            if($sql_r2 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            $q_kekka_2 = $sql_r2->fetch_assoc();
            if($q_kekka_2["cnt"] >= $this->config["one_time_tokens_per_user"]){
                $sql_r3 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `user_id`='".$user_id."' order by `token_created` limit 1");
                if($sql_r3 === FALSE){
                    print "SQL文の実行に失敗しました。".$this->db_obj->error;
                    return FALSE;
                }
            }
            
            $sql_r4 = $this->db_obj->query("INSERT INTO `wakarana_one_time_tokens`(`token`,`user_id`,`token_created`) VALUES ('".$token."','".$user_id."','".date("Y-m-d H:i:s",$ima)."')");
            if($sql_r4 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
        }
        
        return $token;
    }
    
    
    function check_one_time_token($user_id,$token){
        $user_id = $this->escape_id($user_id);
        
        if($this->config["use_sqlite"]){
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `token`='".$this->db_obj->escapeString($token)."' AND `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            if($this->db_obj->changes() >= 1){
                return TRUE;
            }
        }else{
            $sql_r1 = $this->db_obj->query("DELETE FROM `wakarana_one_time_tokens` WHERE `token`='".$this->db_obj->real_escape_string($token)."' AND `user_id` = '".$user_id."'");
            if($sql_r1 === FALSE){
                print "SQL文の実行に失敗しました。".$this->db_obj->error;
                return FALSE;
            }
            
            if($this->db_obj->affected_rows >= 1){
                return TRUE;
            }
        }
        
        return FALSE;
    }
}
?>