<?php
$db_obj = new SQLite3(dirname(__DIR__)."/data/social_amniote.db");
$db_obj->busyTimeout(5000);

function db_get_sns_accounts($user_id) {
    global $db_obj;
    
    $sqlite_r1 = $db_obj->query("SELECT * FROM `social_amniote_sns_accounts` WHERE `user_id` = '".$db_obj->escapeString($user_id)."' ORDER BY `display_order` ASC;");
    if($sqlite_r1 == FALSE){
        print "db_get_sns_accountsのSQL実行に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    $sns_accounts = array();
    for ($cnt = 0; $account_data = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++) {
        $sns_accounts[$cnt] = $account_data;
    }
    
    return $sns_accounts;
}

function db_get_display_order($user_id, $instance_url, $username) {
    global $db_obj;
    
    $user_id = $db_obj->escapeString($user_id);
    
    $sqlite_r1 = $db_obj->query("SELECT `display_order` FROM `social_amniote_sns_accounts` WHERE `user_id` = '".$user_id."' AND `instance_url` = '".$db_obj->escapeString($instance_url)."' AND `username` = '".$db_obj->escapeString($username)."';");
    if($sqlite_r1 == FALSE){
        print "SQLコード1の実行に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    $data = $sqlite_r1->fetchArray(SQLITE3_ASSOC);
    if ($data === FALSE) {
        $sqlite_r2 = $db_obj->query("SELECT `display_order` FROM `social_amniote_sns_accounts` WHERE `user_id` = '".$user_id."' ORDER BY `display_order` DESC LIMIT 1;");
        if($sqlite_r2 == FALSE){
            print "SQLコード2の実行に失敗しました。".$db_obj->lastErrorMsg();
            exit();
        }
        
        $last_order = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        if ($last_order !== FALSE) {
            return $last_order["display_order"] + 1;
        } else {
            return 1;
        }
    } else {
        return $data["display_order"];
    }
}

function db_add_new_instance($instance_url, $sns, $client_id, $client_secret) {
    global $db_obj;
    
    $sqlite_r1 = $db_obj->query("REPLACE INTO `social_amniote_sns_instances`(`instance_url`, `sns`, `client_id`, `client_secret`) values ('".$db_obj->escapeString($instance_url)."', '".$db_obj->escapeString($sns)."', '".$db_obj->escapeString($client_id)."', '".$db_obj->escapeString($client_secret)."');");
    if($sqlite_r1 == FALSE){
        print "db_add_new_instanceのSQL実行に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
}

function db_add_new_sns_account($user_id, $instance_url, $username, $display_name, $display_order) {
    global $db_obj;
    
    $user_id = $db_obj->escapeString($user_id);
    
    $sqlite_r1 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `access_token` = NULL WHERE `user_id` = '".$user_id."' AND `access_token` = '<WAITING>';");
    if($sqlite_r1 == FALSE){
        print "db_add_new_sns_accountのSQL実行1に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    $sqlite_r2 = $db_obj->query("REPLACE INTO `social_amniote_sns_accounts`(`user_id`, `instance_url`, `username`, `display_name`, `display_order`, `access_token`, `checked`) values ('".$user_id."', '".$db_obj->escapeString($instance_url)."', '".$db_obj->escapeString($username)."', '".$db_obj->escapeString($display_name)."', ".intval($display_order).", '<WAITING>', 1);");
    if($sqlite_r2 == FALSE){
        print "db_add_new_sns_accountのSQL実行2に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
}

function db_swap_sns_account($user_id, $display_order_1, $display_order_2) {
    global $db_obj;
    
    $user_id = $db_obj->escapeString($user_id);
    $display_order_1 = intval($display_order_1);
    $display_order_2 = intval($display_order_2);
    
    $sqlite_r1 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `display_order` = 0 WHERE `user_id` = '".$user_id."' AND `display_order` = ".$display_order_1.";");
    if($sqlite_r1 == FALSE){
        print "swap_sns_accountのSQL実行1に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    $sqlite_r2 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `display_order` = ".$display_order_1." WHERE `user_id` = '".$user_id."' AND `display_order` = ".$display_order_2.";");
    if($sqlite_r2 == FALSE){
        print "swap_sns_accountのSQL実行2に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    $sqlite_r3 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `display_order` = ".$display_order_2." WHERE `user_id` = '".$user_id."' AND `display_order` = 0;");
    if($sqlite_r3 == FALSE){
        print "swap_sns_accountのSQL実行3に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
}

function db_delete_sns_account($user_id, $display_order) {
    global $db_obj;
    
    $user_id = $db_obj->escapeString($user_id);
    $display_order = intval($display_order);
    
    $sqlite_r1 = $db_obj->query("DELETE FROM `social_amniote_sns_accounts` WHERE `user_id` = '".$user_id."' AND `display_order` = ".$display_order.";");
    if($sqlite_r1 == FALSE){
        print "delete_sns_accountのSQL実行1に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    $sqlite_r2 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `display_order` = `display_order` - 1 WHERE `user_id` = '".$user_id."' AND `display_order` > ".$display_order.";");
    if($sqlite_r2 == FALSE){
        print "delete_sns_accountのSQL実行2に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
}

function db_set_checked($user_id, $display_order, $checked) {
    global $db_obj;
    
    $user_id = $db_obj->escapeString($user_id);
    $display_order = intval($display_order);
    
    if (empty($checked)) {
        $checked_sql = "0";
    } else {
        $checked_sql = "1";
    }
    
    $sqlite_r1 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `checked` = ".$checked_sql." WHERE `user_id` = '".$user_id."' AND `display_order` = ".$display_order.";");
    if($sqlite_r1 == FALSE){
        print "db_set_checkedのSQL実行1に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
}

function db_get_instance_data($instance_url) {
    global $db_obj;
    
    $sqlite_r1 = $db_obj->query("SELECT * FROM `social_amniote_sns_instances` WHERE `instance_url` = '".$db_obj->escapeString($instance_url)."';");
    if($sqlite_r1 == FALSE){
        print "db_get_instance_dataのSQL実行に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    return $sqlite_r1->fetchArray(SQLITE3_ASSOC);
}

function db_get_instance_waiting($user_id) {
    global $db_obj;
    
    $sqlite_r1 = $db_obj->query("SELECT * FROM `social_amniote_sns_instances` WHERE `instance_url` IN (SELECT `instance_url` FROM `social_amniote_sns_accounts` WHERE `user_id` = '".$db_obj->escapeString($user_id)."' AND `access_token` = '<WAITING>');");
    if($sqlite_r1 == FALSE){
        print "db_get_instance_dataのSQL実行に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
    
    return $sqlite_r1->fetchArray(SQLITE3_ASSOC);
}

function db_register_token($user_id, $access_token, $access_token_secret = NULL) {
    global $db_obj;
    
    if ($access_token_secret != NULL) {
        $token_secret_str = ", `access_token_secret` = '".$db_obj->escapeString($access_token_secret)."'";
    } else {
        $token_secret_str = "";
    }
    
    $sqlite_r1 = $db_obj->query("UPDATE `social_amniote_sns_accounts` SET `access_token` = '".$db_obj->escapeString($access_token)."'".$token_secret_str."  WHERE `user_id` = '".$db_obj->escapeString($user_id)."' AND `access_token` = '<WAITING>';");
    if($sqlite_r1 == FALSE){
        print "db_register_tokenのSQL実行に失敗しました。".$db_obj->lastErrorMsg();
        exit();
    }
}
