<?php
$q_db_obj = new SQLite3(dirname(__DIR__)."/data/question.db");
$q_db_obj->busyTimeout(5000);

function split_question($question) {
    $question = str_replace("\r\n", "\n", $question);
    
    $nagasa = mb_strlen($question);
    $kakugyo = array();
    $str_offset = 0;
    
    for ($gyosu = 0; $gyosu < 6; $gyosu++) {
        $kaigyo = mb_strpos($question, "\n", $str_offset);
        if ($kaigyo !== FALSE && ($kaigyo - $str_offset) <= 20) {
            $kakugyo[$gyosu] = mb_substr($question, $str_offset, $kaigyo - $str_offset);
            $str_offset = $kaigyo + 1;
        } else {
            $kakugyo[$gyosu] = mb_substr($question, $str_offset, 20);
            $str_offset += 20;
        }
        
        if ($str_offset >= $nagasa) {
            break;
        }
    }
    
    return $kakugyo;
}

function add_question($user_id, $question, $questioner_ip) {
    global $q_db_obj;
    
    $question_id = date("YmdHis").substr(microtime(),2,6);
    
    $question = str_replace("\r\n", "\n", $question);
    
    $sqlite_r1 = $q_db_obj->query("INSERT INTO `social_amniote_questions`(`question_id`, `user_id`, `question`, `question_datetime`, `questioner_ip`) VALUES('".$question_id."', '".$q_db_obj->escapeString($user_id)."', '".$q_db_obj->escapeString($question)."', '".date("Y-m-d H:i:s")."', '".$q_db_obj->escapeString($questioner_ip)."');");
    if($sqlite_r1 == FALSE){
        print "add_questionのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
    
    return $question_id;
}

function get_question($question_id) {
    global $q_db_obj;
    
    $sqlite_r1 = $q_db_obj->query("SELECT * FROM `social_amniote_questions` WHERE `question_id` = '".$q_db_obj->escapeString($question_id)."';");
    if($sqlite_r1 == FALSE){
        print "get_questionのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
    
    return $sqlite_r1->fetchArray(SQLITE3_ASSOC);
}

function get_questions_to_user($user_id, $unanswered_only = TRUE) {
    global $q_db_obj;
    
    if ($unanswered_only) {
        $sql_add = " AND `answer_datetime` IS NULL";
    } else {
        $sql_add = "";
    }
    
    $sqlite_r1 = $q_db_obj->query("SELECT * FROM `social_amniote_questions` WHERE `user_id` = '".$q_db_obj->escapeString($user_id)."'".$sql_add." ORDER BY question_datetime DESC;");
    if($sqlite_r1 == FALSE){
        print "get_questions_to_userのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
    
    $data = array();
    for ($cnt = 0; $data_2 = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++) {
        $data[$cnt] = $data_2;
    }
    
    return $data;
}

function answer_question($user_id, $question_id, $answer) {
    global $q_db_obj;
    
    $sqlite_r1 = $q_db_obj->query("UPDATE `social_amniote_questions` SET `answer` = '".$q_db_obj->escapeString($answer)."', `answer_datetime` = '".date("Y-m-d H:i:s")."' WHERE `user_id` = '".$q_db_obj->escapeString($user_id)."' AND `question_id` = '".$q_db_obj->escapeString($question_id)."';");
    if($sqlite_r1 == FALSE){
        print "answer_questionのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
}

function update_question_read_datetime($user_id) {
    global $q_db_obj;
    
    $sqlite_r1 = $q_db_obj->query("REPLACE INTO `social_amniote_question_read`(`user_id`, `read_datetime`) VALUES('".$q_db_obj->escapeString($user_id)."', '".date("Y-m-d H:i:s")."');");
    if($sqlite_r1 == FALSE){
        print "add_questionのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
}

function get_last_question_read($user_id) {
    global $q_db_obj;
    
    $sqlite_r1 = $q_db_obj->query("SELECT `read_datetime` FROM `social_amniote_question_read` WHERE `user_id` = '".$q_db_obj->escapeString($user_id)."';");
    if($sqlite_r1 == FALSE){
        print "get_last_question_readのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
    
    $data = $sqlite_r1->fetchArray(SQLITE3_ASSOC);
    if (!empty($data)) {
        return $data["read_datetime"];
    } else {
        return "2000-01-01 00:00:00";
    }
}

function count_unread_questions($user_id) {
    global $q_db_obj;
    
    $sqlite_r1 = $q_db_obj->query("SELECT COUNT(*) AS `cnt` FROM `social_amniote_questions` WHERE `user_id` = '".$q_db_obj->escapeString($user_id)."' AND `question_datetime` > '".get_last_question_read($user_id)."'");
    if($sqlite_r1 == FALSE){
        print "get_questions_to_userのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
    
    $data = $sqlite_r1->fetchArray(SQLITE3_ASSOC);
    return $data["cnt"];
}

function delete_question($user_id, $question_id) {
    global $q_db_obj;
    
    $sqlite_r1 = $q_db_obj->query("DELETE FROM `social_amniote_questions` WHERE `user_id` = '".$q_db_obj->escapeString($user_id)."' AND `question_id` = '".$q_db_obj->escapeString($question_id)."';");
    if($sqlite_r1 == FALSE){
        print "delete_questionのSQL実行に失敗しました。".$q_db_obj->lastErrorMsg();
        exit();
    }
}
