<?php
include "../modules/functions.php";
include "../modules/question.php";
include "../lib/wakarana/main.php";
$wakarana = new wakarana();

if (!empty($_SERVER["PATH_INFO"])) {
    $user_id = $wakarana->escape_id(substr($_SERVER["PATH_INFO"], 1));
    $user_data = $wakarana->get_user_info($user_id);
    if (!empty($user_data)) {
        $user_name = addslashes($user_data["user_name"]);
    } else {
        print "存在しないユーザーIDです";
        exit();
    }
} else {
    print "ユーザーIDが指定されていません";
    exit();
}

$question_value = "";
if (isset($_POST["question"])) {
    include "../lib/zizai_captcha/check.php";
    if(zizai_captcha_check()){
        $questioner_ip = $_SERVER["REMOTE_ADDR"];
        $kakugyo = split_question($_POST["question"]);
        if (count($kakugyo) <= 6) {
            $question_id = add_question($user_id, $_POST["question"], $questioner_ip);
            header("Location: ../result.php/".$question_id);
        } else {
            print "質問文が長すぎます";
            exit();
        }
    } else {
        $question_value = $_POST["question"];
    }
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <meta property="twitter:card" content="summary_large_image">
<?php
print "<meta property='og:title' content='".$user_name."に匿名質問を送る'>";
print "<meta property='og:description' content='".$user_name."に匿名質問を送る'>";
print "<meta property='og:image' content='".get_application_url()."images/question.png'>";
print "<meta property='og:url' content='".get_application_url()."question/index.php/".$user_id."'>";
print "<title>".htmlspecialchars($user_data["user_name"])."への匿名質問</title>";
?>
<?php print "<title>".htmlspecialchars($user_data["user_name"])."に匿名質問を送る</title>"; ?>
    <link rel="stylesheet" href="../../main.css" type="text/css">
    <link rel="shortcut icon" href="../../favicon.ico">
</head>
<body>
    <header>匿名質問</header>
<?php
if (!empty($question_value)) {
    print "<span style='color: #ff0000;'>画像認証に失敗しました。<br>お手数ですが再試行してください。</span>";
}
print "<h3>".$user_name."に匿名質問を送る</h3>";
?>
<script>
var content_elm;
var char_cnt_elm;
var post_button_elm;
var screen_elm;
var captcha_popup_elm;

window.addEventListener("load", function(){
    content_elm = document.getElementById("content");
    char_cnt_elm = document.getElementById("char_cnt");
    post_button_elm = document.getElementById("post_button");
    screen_elm = document.getElementById("popup_screen");
    captcha_popup_elm = document.getElementById("captcha_popup");
    
    content_elm.addEventListener("keyup", char_cnt);
    content_elm.addEventListener("paste", char_cnt);
    content_elm.addEventListener("cut", char_cnt);
});

function char_cnt() {
    var question = content_elm.value.replace("\r\n","\n");
    
    var nagasa = question.length;
    var str_offset = 0;
    
    var kaigyo;
    for (var gyosu = 0; gyosu < 100; gyosu++) {
        kaigyo = question.indexOf("\n", str_offset);
        if (kaigyo !== -1 && (kaigyo - str_offset) <= 20) {
            str_offset = kaigyo + 1;
        } else {
            str_offset += 20;
        }
        
        if (str_offset >= nagasa) {
            break;
        }
    }
    
    char_cnt_elm.innerText = (gyosu + 1);
    if (gyosu >= 6) {
        char_cnt_elm.style.color = "#ff0000";
        post_button_elm.disabled = true;
    } else {
        char_cnt_elm.style.color = "";
        post_button_elm.disabled = false;
    }
}

function open_captcha_popup() {
    if (content_elm.value.replace(/[\r\n\s]/g,"").length == 0) {
        alert("質問文が入力されていません");
        return;
    }
    
    screen_elm.style.display = "block";
    captcha_popup_elm.style.display = "block";
}

function close_square_popup() {
    screen_elm.style.display = "none";
    captcha_popup_elm.style.display = "none";
}
</script>
<?php print "<form method='post' action='./".$user_id."'>"; ?>
    <div id="content_wrapper">
        <textarea id="content" name="question" placeholder="ここに質問を入力してください"><?php print htmlspecialchars($question_value); ?></textarea>
    </div>
    <span id="char_cnt">1</span>/6行<button id="post_button" type="button" onclick="open_captcha_popup();">送信</button>
    
    <div id="popup_screen">
        <div class="square_popup" id="captcha_popup">
            <button class="popup_close_button" type="button" onclick="close_square_popup();">×</button>
            <br>
            画像の文字を入力してください<br>
            <br>
            <script src="../../lib/zizai_captcha/captcha.php" type="text/javascript"></script>
            <script>zizai_captcha_show();</script>
            <button type="submit">送信</button>
        </div>
    </div>
</form>
<span id="powered_by">Powered by <a href="../../"><?php print APPLICATION_NAME; ?></a></span>
</body>
</html>
