<?php
include "../modules/functions.php";
include "../modules/question.php";
include "../lib/wakarana/main.php";
$wakarana = new wakarana();

if (!empty($_SERVER["PATH_INFO"]) && !empty(substr($_SERVER["PATH_INFO"], 1))) {
    $q_data = get_question(substr($_SERVER["PATH_INFO"], 1));
    if (empty($q_data)) {
        print "指定された質問IDは存在しません";
        exit();
    }
    
    $user_data = $wakarana->get_user_info($q_data["user_id"]);
} else {
    print "質問IDが指定されていません";
    exit();
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <meta property="twitter:card" content="summary_large_image">
<?php
print "<meta property='og:title' content='".addslashes($user_data["user_name"])."宛の匿名質問'>";
print "<meta property='og:description' content='".addslashes($q_data["question"])."'>";
print "<meta property='og:image' content='".get_application_url()."question/image.php/".$q_data["question_id"]."'>";
print "<meta property='og:url' content='".get_application_url()."question/qa.php/".$q_data["question_id"]."'>";
print "<title>".htmlspecialchars($user_data["user_name"])."宛の匿名質問</title>";
?>
    <link rel="stylesheet" href="../../main.css" type="text/css">
    <link rel="shortcut icon" href="../../favicon.ico">
</head>
<body>
    <header>匿名質問</header>
    <br>
<?php
print "<img src='../image.php/".$q_data["question_id"]."' alt='".addslashes($q_data["question"])."' class='question_image'>";
print "<h3>".htmlspecialchars($user_data["user_name"])."からの回答</h3>";
print "<div id='answer_box'>";
if (!empty($q_data["answer_datetime"])) {
    print nl2br(htmlspecialchars($q_data["answer"]));
} else {
    print "<span style='color: #999999;'>この質問は未回答です</span>";
}
print "</div>";
print "<button id='sign_up_button' onclick='location.href = \"../index.php/".$q_data["user_id"]."\";'>".htmlspecialchars($user_data["user_name"])."に質問を送る</button>";
?>
    <span id="powered_by">Powered by <a href="../../"><?php print APPLICATION_NAME; ?></a></span>
</body>
</html>
