var social_amniote_version = "20.05-6"; /*アプリ本体のバージョン番号*/

var cache_name = "social_amniote_" + social_amniote_version;
var files_to_cache = [
        "index.php",
        "images/social_amniote.png",
        "apple-touch-icon.png",
        "favicon.ico",
        "addition/main.js",
        "main.css"
    ];

self.addEventListener("install", function(event) {
    event.waitUntil(
        caches.open(cache_name).then(function(cache) {
            return cache.addAll(files_to_cache);
        })
    );
});

self.addEventListener("fetch", function(event) {
    event.respondWith(
        caches.match(event.request).then(function(response) {
            if (response) {
                return response;
            }
            
            return fetch(event.request);
        })
    );
});

self.addEventListener("activate", function(event) {
    event.waitUntil(
        caches.keys().then(function(cacheNames) {
            return Promise.all(cacheNames.map(function(cacheName) {
                    if (cacheName != cache_name){
                        return caches.delete(cacheName);
                    }
            }));
        })
    );
});
