<?php
include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if ($user_id == FALSE) {
    header("Location: ../login.php");
    exit(0);
}

include "../modules/functions.php";
include "../modules/db_functions.php";

$sa_config = parse_ini_file("../data/social_amniote.ini");

$instance_access_error = FALSE;

if (isset($_POST["sns"], $_POST["instance_url"], $_POST["username"])) {
    if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
        $username = str_replace("@", "", $_POST["username"]);
        
        if ($_POST["sns"] === "mastodon") {
            $instance_url = str_replace("https://", "", $_POST["instance_url"]);
            
            $client_data = db_get_instance_data($instance_url);
            if ($client_data == FALSE) {
                $client_data = get_mastodon_client_data($instance_url);
                if (isset($client_data["client_id"], $client_data["client_secret"])) {
                    db_add_new_instance($instance_url, "mastodon", $client_data["client_id"], $client_data["client_secret"]);
                } else {
                    $instance_access_error = TRUE;
                }
            }
        } else {
            $instance_url = "twitter.com";
            
            if (empty($sa_config["twitter_consumer_key"])) {
                $instance_access_error = TRUE;
            } else {
                $oauth_token = get_twitter_oauth_token($sa_config["twitter_consumer_key"], $sa_config["twitter_consumer_secret"]);
                if ($oauth_token === FALSE) {
                    $instance_access_error = TRUE;
                }
            }
        }
        
        if (!$instance_access_error) {
            db_add_new_sns_account($user_id, $instance_url, $username, "@".$username."@".$instance_url, db_get_display_order($user_id, $instance_url, $username));
            
            if($_POST["sns"] === "mastodon") {
                header("Location: https://".$instance_url."/oauth/authorize?client_id=".$client_data["client_id"]."&scope=read write follow&response_type=code&force_login=true&redirect_uri=".get_application_url()."register_token/mastodon.php");
            } else {
                header("Location: https://api.twitter.com/oauth/authenticate?".http_build_query(array("oauth_token"=>$oauth_token, "force_login"=>TRUE, "screen_name"=>$username)));
            }
            exit(0);
        }
    }
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>SNSアカウントの追加 | <?php print APPLICATION_NAME; ?></title>
    <link rel="stylesheet" href="../main.css" type="text/css">
    <link rel="shortcut icon" href="../favicon.ico">
</head>
<body>
    <button class="popup_close_button" onclick="location.href = '../index.php';">×</button>
    <h2>SNSアカウントの追加</h2>
<?php
if ($instance_access_error) {
    print "<div id='login_error'>SNSサーバーへのアクセスに失敗しました。</div>\n";
}
?>
    <form method="post" action="add_sns_account.php" class="popup_form">
        <b>SNS</b><br>
        <select id="sns_select" name="sns">
            <option value="mastodon" selected="selected">Mastodon</option>
<?php if (!empty($sa_config["twitter_consumer_key"])) { print "<option value='twitter'>Twitter</option>"; } ?>
        </select><br>
        <br>
        <div id="mastodon_only">
            <b>インスタンスURL</b><br>
            https://<input type="text" name="instance_url"><br>
            ※末尾の「/」は不要<br>
            <br>
        </div>
        <b>ユーザー名</b><br>
        @<input type="text" name="username"><br>
        <br>
        <br>
<?php print "<input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'>"; ?>
        <button type="submit" id="post_button">追加</button>
    </form>
    <script>
        var sns_select = document.getElementById("sns_select");
        var mastodon_only = document.getElementById("mastodon_only");
        sns_select.addEventListener("change", function(){
            if (sns_select.value == "mastodon") {
                mastodon_only.style.display = "block";
            } else {
                mastodon_only.style.display = "none";
            }
        });
    </script>
</body>
</html>
