<?php
include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if ($user_id == FALSE) {
    header("Location: ../login.php");
    exit(0);
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>SNSアカウントの管理 | <?php print APPLICATION_NAME; ?></title>
    <link rel="stylesheet" href="../main.css" type="text/css">
    <link rel="shortcut icon" href="../favicon.ico">
</head>
<body>
    <form id="hidden_form" action="sns_accounts.php" method="post" style="display: none;">
        <input type="hidden" name="command" id="command">
        <input type="hidden" name="arg_1" id="arg_1">
        <input type="hidden" name="arg_2" id="arg_2">
<?php
print "<input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'>";
?>
    </form>
<script>
var form_elm = document.getElementById("hidden_form");
var command_elm = document.getElementById("command");
var arg_1_elm = document.getElementById("arg_1");
var arg_2_elm = document.getElementById("arg_2");

function get_selected_display_order() {
    var account_select_elms = document.getElementsByName("account_select");
    
    for (var cnt = 0; cnt < account_select_elms.length; cnt++) {
        if (account_select_elms[cnt].checked) {
            return cnt + 1;
        }
    }
}

function account_up() {
    var display_order = get_selected_display_order();
    if (display_order == 1) {
        alert("選択中のアカウントは既に一番上です");
        return;
    }
    
    command_elm.value = "swap";
    arg_1_elm.value = display_order;
    arg_2_elm.value = display_order - 1;
    
    form_elm.submit();
}

function account_down() {
    var display_order = get_selected_display_order();
    if (display_order == document.getElementsByName("account_select").length) {
        alert("選択中のアカウントは既に一番下です");
        return;
    }
    
    command_elm.value = "swap";
    arg_1_elm.value = display_order;
    arg_2_elm.value = display_order + 1;
    
    form_elm.submit();
}

function account_delete() {
    var display_order = get_selected_display_order();
    
    if (!confirm(accounts_display_name[display_order - 1] + "を登録解除しますか？")) {
        return;
    }
    
    command_elm.value = "delete";
    arg_1_elm.value = display_order;
    
    form_elm.submit();
}

function change_checked() {
    var display_order = get_selected_display_order();
    
    command_elm.value = "check";
    arg_1_elm.value = display_order;
    
    if (accounts_is_checked[display_order - 1]) {
        arg_2_elm.value = "0";
    } else {
        arg_2_elm.value = "1";
    }
    
    form_elm.submit();
}

function selected_is_checked() {
    if (accounts_is_checked[get_selected_display_order() - 1]) {
        is_checked_elm.checked = true;
    } else {
        is_checked_elm.checked = false;
    }
}

var accounts_display_name = new Array();
var accounts_is_checked = new Array();
</script>
    <button class="popup_close_button" onclick="location.href = '../index.php';">×</button>
<?php
include "../modules/db_functions.php";

$selected_number = 0;

if (isset($_POST["command"], $_POST["arg_1"], $_POST["arg_2"])) {
    if ($wakarana->check_one_time_token($user_id,$_POST["token"])) {
        
        switch ($_POST["command"]) {
            case "swap":
                db_swap_sns_account($user_id, $_POST["arg_1"], $_POST["arg_2"]);
                
                $selected_number = intval($_POST["arg_2"]) - 1;
                break;
            case "delete":
                db_delete_sns_account($user_id, $_POST["arg_1"]);
                break;
            case "check":
                db_set_checked($user_id, $_POST["arg_1"], $_POST["arg_2"]);
                
                $selected_number = intval($_POST["arg_1"]) - 1;
                break;
        }
    } else {
        print "<span style='font-size: x-large; color: #ff0000;'>ワンタイムトークンが無効です。<br>変更は破棄されました。</span><br><br>";
    }
}
?>
    <h2>SNSアカウントの管理</h2>
    <div class="radio_select" onclick="setTimeout(selected_is_checked, 100);">
<?php
$sns_accounts = db_get_sns_accounts($user_id);

$cnt_max = count($sns_accounts);
for ($cnt = 0; $cnt < $cnt_max; $cnt++) {
    if ($cnt == $selected_number) {
        $selected_html = " checked='checked'";
    } else {
        $selected_html = "";
    }
    
    print "<input type='radio' name='account_select' id='account_select_".$cnt."'".$selected_html."><label for='account_select_".$cnt."'>".htmlspecialchars($sns_accounts[$cnt]["display_name"])."</label><br>";
    print "<script>accounts_display_name.push('".addslashes($sns_accounts[$cnt]["display_name"])."'); accounts_is_checked.push(".addslashes($sns_accounts[$cnt]["checked"]).");</script>";
}
?>
    </div>
    <div class="up_down_button_wrapper">
        <button class="up_down_button" onclick="account_up();">▲</button>
        <button class="up_down_button" onclick="account_down();">▼</button>
        <br>
        <button class="up_down_button" onclick="account_delete();">×</button>
    </div>
    <h4>初期チェック状態</h4>
    <input type="checkbox" id="is_checked" class="account_checkbox" onclick="change_checked();"><label for="is_checked">チェック済みにする</label>
<script>
var is_checked_elm = document.getElementById("is_checked");
selected_is_checked();
</script>
</body>
</html>