<?php
include "lib/wakarana/main.php";

$wakarana = new wakarana();

include "modules/functions.php";
include "modules/db_functions.php";
include "lib/zizai_captcha/check.php";

if (isset($_POST["user_id"], $_POST["password"])) {
    if (zizai_captcha_check()) {
        if ($wakarana->get_user_info($_POST["user_id"]) === NULL) {
            $wakarana->add_user($_POST["user_id"], $_POST["password"]);
            
            $wakarana->login($_POST["user_id"], $_POST["password"]);
            header("Location: index.php");
            exit();
        } else {
            $err_mes = "入力されたユーザーIDは既に他の人が使用しています<br>異なるユーザーIDを指定してください";
        }
    } else {
        $err_mes = "画像認証が間違っています";
    }
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>新規登録 | <?php print APPLICATION_NAME; ?></title>
    <link rel="stylesheet" href="main.css" type="text/css">
    <link rel="apple-touch-icon" href="apple-touch-icon.png">
    <link rel="shortcut icon" href="favicon.ico">
</head>
<body>
    <h2>新規登録</h2>
<?php
if (!empty($err_mes)) {
    print "<div id='login_error'>".$err_mes."</div>\n";
}
?>
    <form method="post" action="sign_up.php" class="popup_form">
        <h3>ユーザーID</h3>
        <input type="text" name="user_id">
        半角英数字とアンダーバー(_)以外の文字はご利用いただけません<br>
        <span style="color: #999999;">※このユーザーIDは<?php print APPLICATION_NAME; ?>へのログインのみに使用するものであり、SNSのユーザー名と同じである必要はありません。</span>
        
        <h3>パスワード</h3>
        <input type="password" name="password">
        安全性向上のため、SNSとは異なるパスワードを設定することを推奨します
        
        <h3>画像認証</h3>
        以下の画像の文字を入力してください<br>
        <script src="lib/zizai_captcha/captcha.php" type="text/javascript"></script>
        <script>zizai_captcha_show();</script><br>
        
        <button type="submit">登録</button>
    </form>
</body>
</html>
